﻿#include "model.h"
static int HaveAGoodDay;
namespace mm {
#line 1 "code/Immigration.mpp"
//LABEL(Immigration, EN) Immigration

/*  NOTE(Immigration, EN)

    Added at Step 8

    This module implements immigration. Immigration can be switched on and off.
    Model parameters are the number and sex of immigrants by year, the age distribution by sex, 
    and the distribution of destination provinces by sex and age.
    Immigrants are created at the moment of immigration with the age at immigration
*/

//parameters
//{
//    logical	ModelImmigration;                                               //EN Switch immigration on/off
//    double	NumberImmigrants[SIM_YEAR_RANGE][SEX];                          //EN Number of immigrants
//    model_generated cumrate[2] NumberImmigrantsTable[SIM_YEAR_RANGE][SEX];  //EN Number of immigrants (sampling)
//    cumrate	AgeImmigrants[SEX][AGE_RANGE];                                  //EN Age distribution of immigrants
//    cumrate	DestinationImmigrants[SEX][AGE5_PART][PROVINCE_NAT];            //EN Destination of immigrants
//};

//parameter_group PG_Immigration                                              //EN Immigration
//{
//    ModelImmigration, NumberImmigrants, AgeImmigrants, DestinationImmigrants
//};

//actor Person
//{
//    TIME    time_of_immigration = { TIME_INFINITE };                        //EN Time of immigration
//    void    GetImmigrantCharacteristics();                                  //EN Sample immigrant characteristics
//};

void Person::GetImmigrantCharacteristics()
{
    // Sex and time of immigration
    int nSex, nYear;
    Lookup_NumberImmigrantsTable(RandUniform(11), &nYear, &nSex);
     poStateFunctions->Set_sex(  (SEX)nSex );
     time_of_immigration =   MIN(SIM_YEAR_RANGE) + nYear + RandUniform(12) ;

    // Time of birth 
    int nAge;
    Lookup_AgeImmigrants(RandUniform(14), sex , &nAge);
    double dAge = nAge + RandUniform(13);
     poStateFunctions->Set_time_of_birth(   time_of_immigration - dAge );

    // Province of immigration
    int nProvince;
    Lookup_DestinationImmigrants(RandUniform(9), sex , SPLIT(nAge, AGE5_PART), &nProvince);
     poStateFunctions->Set_province_nat(  (PROVINCE_NAT)nProvince );
//12
     poStateFunctions->Set_province_birth(  (PROVINCE_INT)(SIZE(PROVINCE_INT) - 1) );    // abroad is last category
}


} // namespace 
