﻿#include "model.h"
static int HaveAGoodDay;
namespace mm {
#line 1 "code/Tables.mpp"
//LABEL(Tables, EN) Output Tables

/*	NOTE(Tables, EN)

	Extended and modified at Step 19

    This module contains all tables of the model. Tables can be placed anywhere in the code,
	and/or spread to various files. In simple models, putting all tables together like here
	is a good way to organize code. 
*/

/////////////////////////////////////////////////////////////////////////////////////////
// Table groups for organizing tables in the user interface                            //
/////////////////////////////////////////////////////////////////////////////////////////

//table_group TG01_PopulationTables                           //EN Population
//{
//    TabTotalPopulationSexProvince,
//    TabPopulationAgeSexProvince,
//    TabSimulatedStartingPopulation
//};

//table_group TG_02_FertilityTables							//EN Fertility
//{
//    TabFertilityRates,
//    TabNumberBirths,
//    TabBirthsByAgeGroup,
//    TabAgeAtBirth
//};

//table_group TG_03_MortalityTables                           //EN Mortality
//{
//    TabDeathRates,
//    TabDeathsByAgeGroup,
//    TabCohortChildMortality,
//    TabMortalityTrendFactor
//};

//table_group TG_04_MigrationTables                           //EN Migration
//{
//    TabInternalMigrationRate,
//    TabImmigrationSexProvinceAge,
//    TabEmigration
//};

//table_group TG_05_UnionTables                               //EN First union formation
//{
//    TabUnionFormation,
//    TabAgeAtFirstUnionFormation
//};

//table_group TG_06_EducationTables                           //EN Education
//{
//    TabPopProvAgeEducSex,
//    TabEduc12ByPob,
//    TabEduc12ByPor,
//    TabEduc2015, TabEduc2040, TabEduc2065
//    
//};

//table_group TG_07_CohortTables                              //EN Cohort measures
//{
//    TabMothersExperience
//};


/////////////////////////////////////////////////////////////////////////////////////////
// States and dimensions used in tables only (can be removed with tables)              //
/////////////////////////////////////////////////////////////////////////////////////////

//partition   LITTLE_TIME{ 0.001 };                                           //EN A very small time period
//partition   AGE_15_17{ 15,17 };                                             //EN Age groups 
//partition   AGE_MORT{ 1,5,15,65 };                                          //EN Age groups
//partition   AGE_FIVE{5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80};            //EN Age groups
//range       SIM_YOB_RANGE{ 2013,2060 };                                     //EN Year of birth
//range       CHILD_MORT_RANGE{ 0,14 };                                       //EN Child mortality age range

//actor Person
//{
//    logical is_child = (integer_age < 15);                                  //EN Child < 15
//    logical is_old = (integer_age >= 60);                                   //EN Person 60+
//    logical is_aded0 = (!is_child && !is_old && primary_level == PL_NO);    //EN Person 15-59 never enterd primary
//    logical is_aded1 = (!is_child && !is_old && primary_level == PL_ENTER); //EN Person 15-59 uncompleted primary
//    logical is_aded2 = (!is_child && !is_old && primary_level == PL_GRAD);  //EN Person 15-59 primary graduate
//
//    FERTILE_AGE_RANGE fert_age = COERCE(FERTILE_AGE_RANGE, integer_age);    //EN Age
//    SIM_YEAR_RANGE    sim_yob = COERCE(SIM_YOB_RANGE, year_of_birth);       //EN Year of birth
//    CHILD_MORT_RANGE  sim_cmr = COERCE(CHILD_MORT_RANGE,integer_age);       //EN Age
//
//    //EN Indicator to exclude the number of children assigned at immigration from birth counts
//    logical count_parity = self_scheduling_split(duration(set_alive, TRUE), LITTLE_TIME);
//    logical in_capital = (province_nat == PN_PROV12) ? TRUE:FALSE;
//};

//actor ChildMortalityCalibrator
//{
//    //EN Calendar Year
//    SIM_YEAR_RANGE c_year = COERCE(SIM_YEAR_RANGE,self_scheduling_int(time));
//
//    //EN Mortality trend calibration factor - male
//    double MaleMortalityTrend = MortalityTrend[RANGE_POS(SIM_YEAR_RANGE, c_year)][MALE];
//
//    //EN Mortality trend calibration factor - female
//    double FemaleMortalityTrend = MortalityTrend[RANGE_POS(SIM_YEAR_RANGE, c_year)][FEMALE];
//};


/////////////////////////////////////////////////////////////////////////////////////////
// General Population Tables                                                           //
/////////////////////////////////////////////////////////////////////////////////////////

//table Person TabTotalPopulationSexProvince  //EN Total population by sex and province
//[in_projected_time]
//{
//    sex + *
//    {
//        duration()   //EN Average Population
//    }
//*sim_year
//* province_nat +
//};

//table Person TabPopulationAgeSexProvince  //EN Total population by age group, sex and province
//[in_projected_time]
//{
//    sex+ *
//    province_nat+ *
//    {
//        duration()                  //EN Average Population
//    }
//    * split(integer_age, AGE5_PART) //EN Age group
//    * sim_year                      //EN Calendar Year        
//};

//table Person TabSimulatedStartingPopulation  //EN Simulated starting population by age, sex and province
//[trigger_entrances(in_projected_time, TRUE)]
//{
//    sex + *
//    {
//        unit	//EN Persons  
//    }
//    * integer_age +
//    * province_nat +
//};

/////////////////////////////////////////////////////////////////////////////////////////
// Fertility Tables                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////

//table Person TabFertilityRates							//EN Fertility rates
//[ in_projected_time && WITHIN(FERTILE_AGE_RANGE, integer_age)
//  && sex == FEMALE && count_parity ]
//{
//    {
//        parity / duration()								//EN Fertility rates decimals=4
//    }
//    *sim_year
//    * fert_age
//};

//table Person TabNumberBirths							//EN Number of births
//[in_projected_time && person_type == PT_CHILD]
//{
//    {
//        entrances(set_alive, TRUE) 					    //EN Births
//    }
//    * sim_year
//    * sex +
//};

//table Person TabBirthsByAgeGroup							//EN Births by age of mother
//[in_projected_time && count_parity]
//{
//    {
//        parity, 		                                    //EN Births
//        transitions(parity,0,1)                             //EN First births
//    }
//    *split(integer_age,AGE_15_17) +                        //EN Age group
//    *sim_year                                              //EN Calendar Year        
//};

//table Person TabAgeAtBirth 		                                        //EN Age at birth
//[in_projected_time && sex == FEMALE && count_parity]
//{
//    primary_level + *
//    {
//        value_at_transitions(parity,0,1,age) / transitions(parity,0,1), //EN Average age at first birth decimals=2
//        value_at_changes(parity,age) / changes(parity)                  //EN Average age at birth decimals=2
//    }
//    *sim_year                                                           //EN Calendar Year        
//};

/////////////////////////////////////////////////////////////////////////////////////////
// Mortality Tables                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////

//table Person TabDeathRates                                  //EN Death rates and events by age
//[in_projected_time]
//{
//    sex + *
//    {
//        transitions(alive, TRUE, FALSE),                    //EN Number of persons dying at this age	
//        transitions(alive, TRUE, FALSE) / duration()        //EN Death Rate decimals=4
//    }
//*sim_year
//* integer_age
//};

//table Person TabDeathsByAgeGroup                            //EN Deaths by age group
//[in_projected_time]
//{
//    {
//        transitions(alive, TRUE, FALSE),                    //EN Number of persons dying at this age	
//        transitions(alive, TRUE, FALSE) / duration()        //EN Death Rate decimals=4
//    }
//    *sim_year                                              //EN Calendar Year        
//    * split(integer_age, AGE_MORT) +                        //EN Age group
//};

//table Person TabCohortChildMortality				        //EN Cohort child mortality rates
//[in_projected_time && WITHIN(SIM_YOB_RANGE, year_of_birth) && WITHIN(CHILD_MORT_RANGE, integer_age)]
//{
//    {
//        transitions(alive, TRUE, FALSE) / duration()	    //EN Mortality decimals=4
//    }
//    * sim_cmr                                               //EN Age
//    * sim_yob                                               //EN Year of birth 
//};

//table ChildMortalityCalibrator TabMortalityTrendFactor      //EN Mortality calibration factor 
//{
//    c_year *
//    {
//        value_out(MaleMortalityTrend),                      //EN Male Mortality Trend decimals=4
//        max_value_out(FemaleMortalityTrend)                 //EN Female Mortality Trend decimals=4
//    }
//};

/////////////////////////////////////////////////////////////////////////////////////////
// Migration Tables                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////

//table Person TabInternalMigrationRate                       //EN Internal migration rate
//[ in_projected_time ]
//{
//    sex + *
//    {
//        number_moves / duration()					        //EN Migration rate decimals=4
//    }
//    * split(integer_age, AGE5_PART)                         //EN Age group
//    * province_nat +
//};

//table Person TabImmigrationSexProvinceAge       //EN Immigration by sex, province and age group
//[person_type == PT_IMMIGRANT && in_projected_time && trigger_entrances(set_alive, TRUE)]
//{
//    sex + *
//    province_nat + *
//    {
//        unit 					                                    //EN Immigrants
//    }
//    * split(integer_age, AGE5_PART)+                                //EN Age group
//    * sim_year
//};

//table Person TabEmigration                             //EN Emigration rates and numbers
//[in_projected_time]
//    {
//        sex + *
//        province_nat + *
//        {
//            transitions(has_emigrated, FALSE, TRUE) / duration(),   //EN Emigration rates decimals=4
//            transitions(has_emigrated, FALSE, TRUE)                 //EN Emigrants
//    }
//    * split(integer_age, AGE5_PART)+                                //EN Age group
//    * sim_year
//};

/////////////////////////////////////////////////////////////////////////////////////////
// Education Tables                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////

//table Person TabPopProvAgeEducSex	//EN Population by province, age group, sex and education
//[in_projected_time]
//{
//    province_nat + *
//    sex + *
//    {
//        duration(is_child,TRUE),    //EN Children < 15
//        duration(is_aded0, TRUE),   //EN Persons 15-59 never entered primary school
//        duration(is_aded1, TRUE),   //EN Persons 15-59 primary school non-completer
//        duration(is_aded2, TRUE),   //EN Persons 15-59 primary school graduate
//        duration(is_old,TRUE)       //EN Persons 60+
//    }
//    * sim_year                      //EN Calendar Year        
//};

//table Person TabEduc12ByPob	        //EN Education composition of 12 year old by province of birth 
//[ integer_age==12 && in_projected_time ]
//{
//    province_birth + *
//    sex + *
//    {
//        duration(primary_level,PL_NO) / duration(),     //EN Never entered primary school decimals=2
//        duration(primary_level,PL_ENTER) / duration(),  //EN Primary school non-completer decimals=2
//        duration(primary_level,PL_GRAD) / duration()    //EN Primary school graduate decimals=2
//    }
//    * sim_year
//};

//table Person TabEduc12ByPor	        //EN Education composition of 12 year old by province of residence 
//[integer_age == 12 && in_projected_time]
//{
//    province_nat + *
//    sex + *
//{
//    duration(primary_level,PL_NO) / duration(),    //EN Never entered primary school decimals=2
//        duration(primary_level,PL_ENTER) / duration(),  //EN Primary school non-completer decimals=2
//        duration(primary_level,PL_GRAD) / duration()    //EN Primary school graduate decimals=2
//}
//*sim_year
//};

//table Person TabEduc2015 //EN Population by education 2015
//[calendar_year == 2015]
//{
//    in_capital + *
//    sex + *
//{
//    duration(primary_level,PL_NO),              //EN Never entered primary school
//        duration(primary_level,PL_ENTER),           //EN Primary school non-completer
//        duration(primary_level,PL_GRAD)             //EN Primary school graduate
//}
//*split(integer_age, AGE_FIVE)                   //EN Age group
//};

//table Person TabEduc2040 //EN Population by education 2040
//[calendar_year == 2040]
//{
//    in_capital + *
//    sex + *
//{
//    duration(primary_level,PL_NO),              //EN Never entered primary school
//        duration(primary_level,PL_ENTER),           //EN Primary school non-completer
//        duration(primary_level,PL_GRAD)             //EN Primary school graduate
//}
//*split(integer_age, AGE_FIVE)                   //EN Age group
//};

//table Person TabEduc2065 //EN Population by education 2065
//[calendar_year == 2065]
//{
//    in_capital + *
//    sex + *
//{
//    duration(primary_level,PL_NO),              //EN Never entered primary school
//        duration(primary_level,PL_ENTER),           //EN Primary school non-completer
//        duration(primary_level,PL_GRAD)             //EN Primary school graduate
//}
//*split(integer_age, AGE_FIVE)                   //EN Age group
//};



/////////////////////////////////////////////////////////////////////////////////////////
// Union Tables                                                                        //
/////////////////////////////////////////////////////////////////////////////////////////

//table Person TabUnionFormation	    //EN First union formation by education and age
//[WITHIN(AGE_UNION, integer_age) && sex == FEMALE && in_projected_time && count_parity]
//{
//    {
//        //EN Hazard calculated from parameters decimals=4
//        max_value_in(union_formation_hazard),
//
//        //EN Simulated hazard decimals=4
//        transitions(in_union, FALSE, TRUE) / duration(in_union, FALSE),
//
//        //EN Proportion of women who ever entered a union decimals=4
//        duration(in_union,TRUE) / duration()
//    }
//    * primary_level +
//    * age_union
//    * sim_year
//};

//table Person TabAgeAtFirstUnionFormation //EN Age at first union formation
//[sex == FEMALE && in_projected_time && count_parity]
//{
//    {
//        //EN Average age at first union formation decimals=2
//        value_at_transitions(in_union, FALSE, TRUE,age) / transitions(in_union, FALSE, TRUE)
//    }
//    *primary_level +
//    *sim_year
//};


/////////////////////////////////////////////////////////////////////////////////////////
// Female lifecourse experiences                                                       //
/////////////////////////////////////////////////////////////////////////////////////////


//table Person TabMothersExperience				        //EN Cohort measures of fertility and child deaths
//[ in_projected_time && WITHIN(SIM_YOB_RANGE, year_of_birth) && person_type == PT_CHILD && sex==FEMALE]
//{
//    {
//        //EN Average age at union formation decimals=4
//        value_at_transitions(in_union, FALSE, TRUE,age) / transitions(in_union, FALSE, TRUE), 
//        
//        //EN Average age at first birth decimals=4
//        value_at_transitions(parity,0,1,age) / transitions(parity,0,1),
//
//        //EN Proportion surviving until age 10 decimals=4    
//        transitions(integer_age, 9,10) / unit,
//    
//        //EN Proportion surviving until age 20 decimals=4
//        transitions(integer_age, 14,15) / unit,
//
//        //EN Proportion surviving until age 20 decimals=4
//        transitions(integer_age, 19,20) / unit,
//
//        //EN Proportion graduating from primary school until age 20 decimals=4
//        entrances(primary_level, PL_GRAD) / unit,
//
//        //EN Cohort Fertility (subject to mortality) decimals=4
//        parity / unit,  
//        
//        //EN Cohort Fertility of mothers (subject to mortality) decimals=4
//        parity / transitions(parity,0,1),
//    
//        //EN Average number of children dying < age 5 per woman decimals=4
//        infant_deaths / unit,
//
//        //EN Average number of children dying < age 5 per mother decimals=4
//        infant_deaths / transitions(parity,0,1)
//    }
//    * sim_yob                                               //EN Year of birth 
//};





} // namespace 
